on CTCP {
	set x [string index [args] 0]
	set type [string tolower [lindex [args] 1]]
        switch -glob [string toupper [lindex [args] 1]] {
	"VER*" {
		if {$x == "&" || $x == "#"} {
			/raw notice [nick] :VERSION XiRCON 1.0B1 + $script\
			echo "[color ctcp]*** [color nick][nick][color ctcp] versioned everyone on [color nick][lindex [args] 0]"
			complete
		} {
			/raw notice [nick] :VERSION XiRCON 1.0B1 + $script\
			echo "[color ctcp]*** [color nick][nick][color ctcp] requested your version"
			complete
		}
	}
	"*" {
	if {$type != "action"} {
		if {$x == "&" || $x == "#"} {
			echo "[color ctcp]*** [color nick][nick][color ctcp] $type\ed everyone on [color channel][lindex [args] 0]"
		} {
			echo "[color ctcp]*** [color nick][nick][color ctcp] $type\ed you"
		}
	}
	}	
		
    }
}

on CTCP_REPLY {
	set nick [nick]
	set type [lindex [args] 1]
	set reply [join [lrange [args] 2 end]]
	if {$type == "PING"} {
		echo "[color ctcp]*** PING reply from [color nick]$nick[color public]: [tconv [expr [clock seconds] - [lindex $reply 0]]]"
		complete
	} {
		echo "[color ctcp]*** $type reply from [color nick]$nick[color public]: $reply"
		complete
	}
}
on CONNECT {
	foreach aj $autochans {
		/j $aj
	}
	/raw mode [my_nick] +iw
}

on PRIVMSG {
	set qnick ""
	set text [lrange [args] 1 end]
	set realtext [join [lrange [args] 1 end]]
	set dest [string tolower [lindex [args] 0]]
	set x [string index $dest 0]
	if {$x == "&" || $x == "#"} {
		foreach words $text {
			foreach abc $highlights {
				if {[string first [string tolower $abc] [string tolower $words]] >= 0} {
					set highlightit 1
				}
			}
		}
		if {$highlightit==1} {
			echo "[color nick][color ctcp][nick][color nick]?[color public] $realtext" channel $dest
			set highlightit 0
			complete
		} {
			echo "[color nick]\[[color public][nick][color nick]\][color public] $realtext" channel $dest
			complete
		}
	} {
		if {$wantquery} {
			foreach q [queries] {
				if {[string tolower $q]==[string tolower [nick]]} {
					set qnick $q
				}
			}
			if {$qnick != ""} {
				echo "[color nick]\[[color public][nick][color nick]\][color public] $realtext" query $qnick
				complete
			} {
				/query [nick]
				echo "[color nick]\[[color public][nick][color nick]\][color public] $realtext" query [nick]
				complete
			}
		} {
			echo "[color ctcp]\[[color public][nick][color ctcp]\([color public][user][color ctcp]@[color public][host][color ctcp]\)\][color public] $text" [window_type] [window_name]
			complete
		}
	}
}

on 302 {
  if {$ban_pending == 1} {
    set ban_user [string trimleft [string trimleft [lindex [split [lindex [split [lindex [args] 1] @] 0] =] 1] +] -]
    set ban_host [lindex [split [lindex [args] 1] @] 1]
    set ban_mask $ban_host
    if {[string first "." $ban_mask] == [string last "." $ban_mask] || [isip "$ban_mask"] == 1} {
      if {[isip "$ban_mask"] == 1} { 
        /raw mode $ban_chan -o+b $ban_nick *!*[string range $ban_user [expr [string first "~" $ban_user] + 1] end]@[join [lreplace [split "$ban_mask" .] 3 3 "*"] .]
        } { 
        /raw mode $ban_chan -o+b $ban_nick *!*[string range $ban_user [expr [string first "~" $ban_user] + 1] end]@$ban_mask 
        }
      } { 
      /raw mode $ban_chan -o+b $ban_nick *!*[string range $ban_user [expr [string first "~" $ban_user] + 1] end]@*[string range $ban_mask [string first "." $ban_mask] end] 
      }
    /raw kick $ban_chan $ban_nick :$ban_reason
    set ban_pending 0
    complete
    }
}

on 367 {
	if {$mub_pending == 1} {
		lappend mub_data [lindex [args] 2]
			if {[llength $mub_data] == 4} {
			/raw mode [channel] -bbbb $mub_data
			set mub_data ""
			}
	complete
	}
}

on 368 {
	if {$mub_pending == 1} {
		if {[llength mub_data] > 0} {
			/raw mode [channel] -bbbb $mub_data
		}
	set mub_pending 0
	complete
	}
}

on 333 {
	echo "[color ctcp]***[color public] Topic on [color channel][lindex [args] 1][color public] set by [color nick][lindex [args] 2][color public] on [clock format [lindex [args] 3] -format "%A %B %d, %Y, at"] [string trimleft [clock format [lindex [args] 3] -format "%I:%M:%S %p"] 0]" channel [lindex [args] 1]
	complete
}

on 306 {
	echo "[color nick]***[color public] You are now [color error]AWAY[color public]."
	if {$gone != 1} {set gone 1}
	complete
}

on 305 {
	echo "[color nick]***[color public] You are now [color error]BACK[color public]."
	set gone 0
	complete
}